Index: src/Fragmentation/Automation/Operations/AsyncOperation.cpp
===================================================================
--- src/Fragmentation/Automation/Operations/AsyncOperation.cpp	(revision 17017ba23edbf313cf0a6d860e5d06ea726b2b6a)
+++ src/Fragmentation/Automation/Operations/AsyncOperation.cpp	(revision 9db22d3dcf243224ac36894c1c0683c009857077)
@@ -27,8 +27,14 @@
 
 #include <boost/bind.hpp>
+#include <boost/function.hpp>
 #include <vector>
 #include "Connection.hpp" // Must come before boost/serialization headers.
 #include "CodePatterns/Info.hpp"
 #include "CodePatterns/Log.hpp"
+
+void NoOp() {}
+
+// static instances
+const boost::function<void ()> AsyncOperation::NoOpCallback = boost::bind(&NoOp);
 
 /** Callback function when an operation has been completed.
@@ -42,4 +48,5 @@
   {
     LOG(1, "INFO: AsyncOperation completed.");
+    callback_on_success();
   }
   else
@@ -48,4 +55,5 @@
     Exitflag = ErrorFlag;
     ELOG(1, e.message());
+    callback_on_failure();
   }
 
@@ -68,4 +76,5 @@
 {
   Info info(__FUNCTION__);
+
   // Resolve the host name into an IP address.
   boost::asio::ip::tcp::resolver resolver(connection_.socket().get_io_service());
@@ -81,3 +90,2 @@
       boost::asio::placeholders::error, ++endpoint_iterator));
 }
-
Index: src/Fragmentation/Automation/Operations/AsyncOperation.hpp
===================================================================
--- src/Fragmentation/Automation/Operations/AsyncOperation.hpp	(revision 17017ba23edbf313cf0a6d860e5d06ea726b2b6a)
+++ src/Fragmentation/Automation/Operations/AsyncOperation.hpp	(revision 9db22d3dcf243224ac36894c1c0683c009857077)
@@ -32,5 +32,9 @@
  * update signal at operation's end is not triggered.
  */
-class AsyncOperation : public Operation, public Observable {
+class AsyncOperation : public Operation, public Observable
+{
+public:
+  //!> static function as default callback on success/failure of operation that does nothing
+  static const boost::function<void ()> NoOpCallback;
 public:
   /** Constructor for class AsyncOperation.
@@ -38,10 +42,16 @@
    * \param _name name for this AsyncOperation for retrieval from a registry
    * \param _connection connection to operate on
+   * \param callback_on_success function to call when operation ends successfully
+   * \param callback_on_failure function to call when operation fails
    */
   AsyncOperation(
       const std::string &_name,
-      Connection &_connection) :
+      Connection &_connection,
+      const boost::function<void ()> &_callback_on_success = NoOpCallback,
+      const boost::function<void ()> &_callback_on_failure = NoOpCallback) :
     Operation(_name, _connection),
-    Observable(_name)
+    Observable(_name),
+    callback_on_success(_callback_on_success),
+    callback_on_failure(_callback_on_failure)
   {}
 
@@ -67,4 +77,10 @@
   /// internal function to disconnect from server
   void disconnect();
+
+private:
+  //!> Callback function on successful end of operation
+  boost::function<void ()> callback_on_success;
+  //!> Callback function on end of operation with failure
+  boost::function<void ()> callback_on_failure;
 };
 
Index: src/Fragmentation/Automation/Operations/Controllers/CheckResultsOperation.hpp
===================================================================
--- src/Fragmentation/Automation/Operations/Controllers/CheckResultsOperation.hpp	(revision 17017ba23edbf313cf0a6d860e5d06ea726b2b6a)
+++ src/Fragmentation/Automation/Operations/Controllers/CheckResultsOperation.hpp	(revision 9db22d3dcf243224ac36894c1c0683c009857077)
@@ -28,6 +28,8 @@
 public:
   /// Constructor for class CheckResultsOperation.
-  CheckResultsOperation(Connection &_connection) :
-    AsyncOperation(std::string("checkresults"), _connection),
+  CheckResultsOperation(Connection &_connection,
+      const boost::function<void ()> &_callback_on_success = NoOpCallback,
+      const boost::function<void ()> &_callback_on_failure = NoOpCallback) :
+    AsyncOperation(std::string("checkresults"), _connection, _callback_on_success, _callback_on_failure),
     jobInfo((size_t)2, 0)
         {}
Index: src/Fragmentation/Automation/Operations/Controllers/GetNextJobIdOperation.hpp
===================================================================
--- src/Fragmentation/Automation/Operations/Controllers/GetNextJobIdOperation.hpp	(revision 17017ba23edbf313cf0a6d860e5d06ea726b2b6a)
+++ src/Fragmentation/Automation/Operations/Controllers/GetNextJobIdOperation.hpp	(revision 9db22d3dcf243224ac36894c1c0683c009857077)
@@ -29,6 +29,8 @@
 public:
   /// Constructor for class GetNextJobIdOperation.
-  GetNextJobIdOperation(Connection &_connection) :
-    AsyncOperation(std::string("getnextjobid"), _connection)
+  GetNextJobIdOperation(Connection &_connection,
+      const boost::function<void ()> &_callback_on_success = NoOpCallback,
+      const boost::function<void ()> &_callback_on_failure = NoOpCallback) :
+    AsyncOperation(std::string("getnextjobid"), _connection, _callback_on_success, _callback_on_failure)
   {}
   /// Destructor for class GetNextJobIdOperation
Index: src/Fragmentation/Automation/Operations/Controllers/ReceiveResultsOperation.hpp
===================================================================
--- src/Fragmentation/Automation/Operations/Controllers/ReceiveResultsOperation.hpp	(revision 17017ba23edbf313cf0a6d860e5d06ea726b2b6a)
+++ src/Fragmentation/Automation/Operations/Controllers/ReceiveResultsOperation.hpp	(revision 9db22d3dcf243224ac36894c1c0683c009857077)
@@ -26,6 +26,9 @@
 public:
   /// Constructor for class ReceiveResultsOperation.
-  ReceiveResultsOperation(Connection &_connection) :
-    AsyncOperation(std::string("receiveresults"), _connection) {}
+  ReceiveResultsOperation(Connection &_connection,
+      const boost::function<void ()> &_callback_on_success = NoOpCallback,
+      const boost::function<void ()> &_callback_on_failure = NoOpCallback) :
+    AsyncOperation(std::string("receiveresults"), _connection, _callback_on_success, _callback_on_failure)
+    {}
   /// Destructor for class ReceiveResultsOperation
   ~ReceiveResultsOperation() {}
Index: src/Fragmentation/Automation/Operations/Controllers/SendJobsOperation.hpp
===================================================================
--- src/Fragmentation/Automation/Operations/Controllers/SendJobsOperation.hpp	(revision 17017ba23edbf313cf0a6d860e5d06ea726b2b6a)
+++ src/Fragmentation/Automation/Operations/Controllers/SendJobsOperation.hpp	(revision 9db22d3dcf243224ac36894c1c0683c009857077)
@@ -26,6 +26,9 @@
 public:
   /// Constructor for class SendJobsOperation.
-  SendJobsOperation(Connection &_connection) :
-    AsyncOperation(std::string("sendjobs"), _connection) {}
+  SendJobsOperation(Connection &_connection,
+      const boost::function<void ()> &_callback_on_success = NoOpCallback,
+      const boost::function<void ()> &_callback_on_failure = NoOpCallback) :
+    AsyncOperation(std::string("sendjobs"), _connection, _callback_on_success, _callback_on_failure)
+    {}
   /// Destructor for class SendJobsOperation
   ~SendJobsOperation() {}
Index: src/Fragmentation/Automation/Operations/Servers/SendJobToWorkerOperation.hpp
===================================================================
--- src/Fragmentation/Automation/Operations/Servers/SendJobToWorkerOperation.hpp	(revision 17017ba23edbf313cf0a6d860e5d06ea726b2b6a)
+++ src/Fragmentation/Automation/Operations/Servers/SendJobToWorkerOperation.hpp	(revision 9db22d3dcf243224ac36894c1c0683c009857077)
@@ -31,6 +31,8 @@
    * @param _connection connection for operation
    */
-  SendJobToWorkerOperation(Connection &_connection) :
-    AsyncOperation(std::string("sendjobtoworker"),_connection),
+  SendJobToWorkerOperation(Connection &_connection,
+      const boost::function<void ()> &_callback_on_success = NoOpCallback,
+      const boost::function<void ()> &_callback_on_failure = NoOpCallback) :
+    AsyncOperation(std::string("sendjobtoworker"),_connection, _callback_on_success, _callback_on_failure),
     job( new SystemCommandJob(std::string("/bin/true"), std::string("donothing"), JobId::NoJob) )
   {}
Index: src/Fragmentation/Automation/Operations/Servers/ShutdownWorkerOperation.hpp
===================================================================
--- src/Fragmentation/Automation/Operations/Servers/ShutdownWorkerOperation.hpp	(revision 17017ba23edbf313cf0a6d860e5d06ea726b2b6a)
+++ src/Fragmentation/Automation/Operations/Servers/ShutdownWorkerOperation.hpp	(revision 9db22d3dcf243224ac36894c1c0683c009857077)
@@ -29,6 +29,8 @@
 public:
   /// Constructor for class ShutdownWorkerOperation.
-  ShutdownWorkerOperation(Connection &_connection) :
-    AsyncOperation(std::string("shutdown"),_connection) {}
+  ShutdownWorkerOperation(Connection &_connection,
+      const boost::function<void ()> &_callback_on_success = NoOpCallback,
+      const boost::function<void ()> &_callback_on_failure = NoOpCallback) :
+    AsyncOperation(std::string("shutdown"),_connection, _callback_on_success, _callback_on_failure) {}
   /// Destructor for class ShutdownWorkerOperation
   ~ShutdownWorkerOperation() {}
Index: src/Fragmentation/Automation/Operations/Workers/EnrollInPoolOperation.hpp
===================================================================
--- src/Fragmentation/Automation/Operations/Workers/EnrollInPoolOperation.hpp	(revision 17017ba23edbf313cf0a6d860e5d06ea726b2b6a)
+++ src/Fragmentation/Automation/Operations/Workers/EnrollInPoolOperation.hpp	(revision 9db22d3dcf243224ac36894c1c0683c009857077)
@@ -29,6 +29,8 @@
 public:
   /// Constructor for class EnrollInPoolOperation.
-  EnrollInPoolOperation(Connection &_connection, const WorkerAddress &_address) :
-    AsyncOperation(std::string("enrollinpool"),_connection),
+  EnrollInPoolOperation(Connection &_connection, const WorkerAddress &_address,
+      const boost::function<void ()> &_callback_on_success = NoOpCallback,
+      const boost::function<void ()> &_callback_on_failure = NoOpCallback) :
+    AsyncOperation(std::string("enrollinpool"),_connection, _callback_on_success, _callback_on_failure),
     address(_address),
     EnrollmentFlag(false)
Index: src/Fragmentation/Automation/Operations/Workers/ObtainJobOperation.hpp
===================================================================
--- src/Fragmentation/Automation/Operations/Workers/ObtainJobOperation.hpp	(revision 17017ba23edbf313cf0a6d860e5d06ea726b2b6a)
+++ src/Fragmentation/Automation/Operations/Workers/ObtainJobOperation.hpp	(revision 9db22d3dcf243224ac36894c1c0683c009857077)
@@ -28,6 +28,9 @@
 public:
   /// Constructor for class ObtainJobOperation.
-  ObtainJobOperation(Connection &_connection) :
-    AsyncOperation(std::string("obtainjob"),_connection) {}
+  ObtainJobOperation(Connection &_connection,
+      const boost::function<void ()> &_callback_on_success = NoOpCallback,
+      const boost::function<void ()> &_callback_on_failure = NoOpCallback) :
+    AsyncOperation(std::string("obtainjob"),_connection, _callback_on_success, _callback_on_failure)
+    {}
   /// Destructor for class ObtainJobOperation
   ~ObtainJobOperation() {}
Index: src/Fragmentation/Automation/Operations/Workers/SubmitResultOperation.hpp
===================================================================
--- src/Fragmentation/Automation/Operations/Workers/SubmitResultOperation.hpp	(revision 17017ba23edbf313cf0a6d860e5d06ea726b2b6a)
+++ src/Fragmentation/Automation/Operations/Workers/SubmitResultOperation.hpp	(revision 9db22d3dcf243224ac36894c1c0683c009857077)
@@ -29,6 +29,8 @@
 public:
   /// Constructor for class SubmitResultOperation.
-  SubmitResultOperation(Connection &_connection, const WorkerAddress &_address) :
-    AsyncOperation(std::string("submitresult"),_connection),
+  SubmitResultOperation(Connection &_connection, const WorkerAddress &_address,
+      const boost::function<void ()> &_callback_on_success = NoOpCallback,
+      const boost::function<void ()> &_callback_on_failure = NoOpCallback) :
+    AsyncOperation(std::string("submitresult"),_connection, _callback_on_success, _callback_on_failure),
     result( new FragmentResult(JobId::NoJob, std::string("EmptyResult")) ),
     address(_address),
